/* Make scrolling smooth */
html,
body,
body *
{
	scroll-behavior: smooth;
}

/* Animate all presentation changes when possible. */
body *
{
	transition: all 400ms ease-out;
}

/* Make a class that flashes an element as to bring attention to it. */
.flash
{
	transition: all 100ms ease-in;
	background-color: var(--pending);
}

/* Set up an animation that rotates an element indefinately */
@keyframes rotate
{
	from { transform: rotate(0deg); }
	to { transform: rotate(359deg); }
}

.rotating
{
	display: inline-block;
	text-align: center;
	vertical-align: middle;

	transform-origin: 50% 50%;

	animation-name: rotate;
	animation-duration: 3000ms;
	animation-iteration-count: infinite;
	animation-timing-function: linear;
	will-change: transform;
}

/* Set up an animation that shakes an element to draw attention to it. */
@keyframes shake
{
	0% { transform: translate(1px, 1px) rotate(0deg); }
	2% { transform: translate(-0px, -1px) rotate(-5deg); }
	4% { transform: translate(-1px, 0px) rotate(4deg); }
	6% { transform: translate(1px, 0px) rotate(-1deg); }
	8% { transform: translate(0px, -1px) rotate(3deg); }
	10% { transform: translate(-1px, 0px) rotate(-6deg); }
	12% { transform: translate(-1px, 1px) rotate(1deg); }
	14% { transform: translate(1px, 1px) rotate(-4deg); }
	16% { transform: translate(-1px, -1px) rotate(3deg); }
	18% { transform: translate(1px, 0px) rotate(2deg); }
	20% { transform: translate(0px, -1px) rotate(-5deg); }
	25% { transform: translate(0px, 0px) rotate(0deg); }
	100% { transform: translate(0px, 0px) rotate(0deg); }
}

.shaking
{
	display: inline-block;
	text-align: center;

	line-height: 1.2em;
	transform-origin: 50% 50%;

	animation: shake 5s;
	animation-delay: 2.5s;
	animation-direction: alternate;
	animation-iteration-count: infinite;
}
